#include <iostream>
#include <set>
#include <cstring>
#include <string>
#include <vector>
using namespace std;
class MNOZINA
{
public:
    MNOZINA(const int & idx,string def)
    :m_Idx(idx),m_Default(def){
        
        for(string::iterator it = def.begin(); it != def.end(); it ++)
            m_Mnozina.insert((*it));
        for(const auto & i: m_Mnozina)
            m_Set+= i;
    }

    int m_Idx;
    string m_Set;
    string m_Default;
    set<char>m_Mnozina;
    friend bool operator < (MNOZINA x, MNOZINA y)
    {
        return x.m_Idx < y.m_Idx;
    }
};


int main(int argc, char** argv) {

    size_t cnt;
    
    while(cin >> cnt)
    {
        vector<MNOZINA> strs;
        string str;
        //---------------------------------------- NACITANI
        for(size_t i = 0; i <= cnt; i ++)
        {
            getline(cin,str);
            if(str.size() <= 1) continue;
            strs.push_back(MNOZINA(i,str));
        }
        //-----------------------------------------
        for(size_t i = 0; i < strs.size(); i ++)
        {
            size_t rightIdx = (i+1 >= strs.size() ? i-1 : i+1);

            if(strs[i].m_Mnozina.size() < cnt)
            {

                for(size_t it = 0; it < strs[rightIdx].m_Default.size(); it ++) 
                {
                    if(strs[i].m_Mnozina.count(strs[rightIdx].m_Default[it]) == 0) 
                    {
                        // NASLI JSME CHYBEJICI ZNAK
                        cout << strs[rightIdx].m_Default[it] << endl;

                        for(size_t j = 0; j < strs[i].m_Default.size(); j++)
                        {
                            for(size_t m = j+1; m < strs[i].m_Default.size(); m++)
                            {
                                if(strs[i].m_Default[j] == strs[i].m_Default[m])
                                {
                                    char tmp = strs[i].m_Default[j];
                                    strs[i].m_Default[j] = strs[rightIdx].m_Default[it];
                                    size_t h = 0;
                                    for(; h < strs.size(); h++)
                                        if(strs[i].m_Default.compare(strs[h].m_Default) == 0) // shoda
                                        {
                                            cout << strs[i].m_Idx << " " << m << " " << strs[rightIdx].m_Default[it]<< endl;
                                        }
                                    strs[i].m_Default[j] = tmp;
                                    if(h == strs.size())
                                    {
                                        cout << strs[i].m_Idx << " " << j << " " << strs[rightIdx].m_Default[it] << endl;
                                    }
                                }
                            }
                        }
                        
                    }
                }
            }
            else
            {
            
            
                //-------------------------
                size_t cntShoda = 0;
                for(size_t j = 0; j < strs.size(); j ++)
                    if(strs[i].m_Set.compare(strs[j].m_Set) == 0) cntShoda ++;

                if(cntShoda == 1)
                {
                    char wrongChar = 0;
                    for(size_t l = 0; l < strs[i].m_Default.size(); l ++)
                    {
                        wrongChar = strs[i].m_Set[l];
                        size_t m = 0;
                        for(; m < strs[i].m_Set.size(); m++)
                            if(strs[i].m_Set[l] == strs[rightIdx].m_Set[m]) break;

                        if(m == strs[i].m_Set.size()) break;
                    }
                    set<char>::iterator it = strs[rightIdx].m_Mnozina.begin();

                    for(; it != strs[rightIdx].m_Mnozina.end(); it ++)
                    {
                        if(strs[i].m_Mnozina.count(*it) == 0) 
                        {
                            size_t res = 0;
                            for(;res < strs[i].m_Default.size(); res++)
                                if(strs[i].m_Default[res] == wrongChar) break;
                            if(res == strs[i].m_Default.size())
                                cout << strs[i].m_Idx << " " << res << " " << *it << endl;
                            else 
                                cout << strs[i].m_Idx << " " << res+1 << " " << *it << endl;
                            break;
                        }
                    }
                    if(it != strs[rightIdx].m_Mnozina.end()) break;
                }
            }
        }
    }
    return 0;
}

